/*
 * This file is part of dial.
 *
 * dial is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 * 
 * dial is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with dial; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Copyright 1994 Dominic Giampaolo
 *   Copyright 1996 Torsten Martinsen
 *
 * $Id: callbacks.c,v 1.18 1996/03/27 18:29:20 torsten Exp $
 */

#include <stdio.h>

#include "dial.h"

static int cstate = CSTATE_NC;

static void listcb(Widget w, char *str, int index, void * junk);

void
connectcb(Widget w, void * junk)
{
  switch (cstate)
    {
    case CSTATE_NC:
      if (number == NULL)
	number = global.defaultnumber;
      set_display_state(DS_CONNECTING);
      SetWidgetState(button, FALSE);
      doconnect(&cstate);
      break;
    case CSTATE_CONNECTED:
    case CSTATE_TRYING:
    case CSTATE_BUSY:
      SetWidgetState(button, FALSE);
      stopclock();
      hangup(hangup_done);
      cstate = CSTATE_NC;
      set_display_state(DS_NOT_CONNECTED);
      break;
    }      
}

void
quitcb(Widget w, void * junk)
{
  if (cstate != CSTATE_NC)
    {
      stopclock();
      hangup(hangup_done);
    }
#if MODULES
#if BSD_COMP
  unload_module("bsd_comp");
#endif
  unload_module("ppp");
  unload_module("slhc");
#endif
  exit(0);
}

#if SELECTNUMBER
/* Work in progress.. */
void
selectcb(Widget w, void * junk)
{
  static char ** items = NULL; /* NULL-terminated */

  if (items == NULL)
    {
    }
  
  MakeWindow("Popup", SAME_DISPLAY, EXCLUSIVE_WINDOW);
  MakeScrollList(items, WIDTH, HEIGHT, listcb, NULL);
  ShowDisplay();

  MainLoop();     /* blocks until CloseWindow() is called */
  
}

static void
listcb(Widget w, char *str, int index, void * junk)
{
  number = str;
  CloseWindow();
}
#endif

void
hangup_done(void)
{
  SetLabel(button, "  Connect  ");
  SetWidgetState(button, TRUE);
}
